;IMPORTANT: this code is currently designed for a single code segment
;and single data segment ASM program.  It will not work properly if
;DS is not set to it's data segment.




segment code

%ifdef MF_NoCursorRoutines
%else

;note: Cursor routines are provided to (possibly) aid linking with C

MF_SetCursor:
	;on entry:
	;CX = desired column
	;DX = desired row
	;on return:
	;CX = new column
	;DX = new row
	;trashed:
	;flags

	and cx,0x007F
	mov [MF_CursorCol],cl
	and dx,0x003F
	mov [MF_CursorRow],dl
	ret

MF_GetCursor:
	;on return:
	;CX = current column
	;DX = current row
	;trashed:
	;flags

	xor cx,cx
	mov cl,[MF_CursorCol]
	xor dx,dx
	mov dl,[MF_CursorRow]
	ret

%endif

MF_CenterForString
	;on entry:
	;DS:SI = ASCIZ string to position screen column in preparation
	;        to center text
	;on return:
	;nothing (column variable is changed)
	;trashed:
	;nothing
	push ax
	push cx
	call MF_FindStringLength
	shr cx,1
	mov ax,63
	sub ax,cx
	mov [MF_CursorCol],al
	pop cx
	pop ax
	ret


MF_FindStringLength:
	;on entry:
	;DS:SI = ASCIZ string to find on-screen length
	;on return:
	;CX = length of string
	;trashed:
	;flags

	cld
	push ax
	push bx
	push si
	xor cx,cx
.lp	lodsb
	or al,al
	jz .exit
	call MF_GetCharData
	and ax,0x0007
	add cx,ax
	jmp short .lp
.exit
	pop si
	pop bx
	pop ax
	ret


MF_DisplayString:
	;on entry:
	;DS:SI = ASCIZ string to display
	;on return:
	;nothing
	;trashed:
	;flags

	pusha
.lp	cld
	lodsb
	or al,al
	jz .exit
	push si
	call MF_DisplayChar
	pop si
	jmp short .lp
.exit
	popa
	ret

MF_DisplayNumAX:
	pusha
	mov bx,0x000a
	xor cx,cx
.LblA	inc cx
	xor dx,dx
	div bx
	push dx
	or ax,ax
	jnz .LblA
.LblB	pop dx
	add dl,0x30
	mov al,dl
	push cx
	call MF_DisplayChar
	pop cx
	loop .LblB
	popa
	ret




MF_DoLineFeed:
	;on entry (nothing)
	;on return (nothing)
	;trashed:
	;dl, flags

	mov [MF_CursorCol],byte 0x00
	mov dl,[MF_CursorRow]
	cmp dl,53
	jbe .noScroll
	;scroll the screen up 6 pixels if needed
	call MF_ScrollUp
	ret
.noScroll
	add [MF_CursorRow],byte 6
MF_Return:
	ret

MF_DisplayChar:
	;on entry:
	;AL = character
	;ES = video segment (IMPORTANT!)
	;on return:
	;nothing
	;trashed:
	;everything except bp and segment registers


	;process line feed character
	cmp al,10
	je MF_DoLineFeed

	call MF_GetCharData

	cld

	xor cx,cx
	mov cl,al
	;and cx,0x07
	or cx,cx
	jz MF_Return

	;first we compute our starting offset for the source byte
	mov al,ah
	xor ah,ah
	mov bx,ax

	shr ax,3
	mov si,ax
	add si,MF_fontimage
	shl ax,2
	add si,ax ;si=(ax\8)*5+FontImageAddress





	;now compute the destination offset

	mov bh,[MF_CursorCol]
	add [MF_CursorCol],cl

	;now if the col>128 we better fix it
	cmp byte [MF_CursorCol],128 ;note there's the nice base zero effect here
	jbe .noCursorAdj
	xor bh,bh
	mov [MF_CursorCol],cl
	xor dx,dx
	add [MF_CursorRow],byte 6
	mov dl,[MF_CursorRow]

	cmp dl,59
	jbe .noReadRow

	;scroll the screen up 6 pixels
	call MF_ScrollUp

	sub byte [MF_CursorRow],byte 6

.noCursorAdj


	xor dx,dx
	mov dl,[MF_CursorRow]

.noReadRow


        ;xchg es,ds
        mov di,ds
	mov ax,es
	mov ds,ax
        mov es,di
	xor ax,ax

	mov di,0x3f
	sub di,dx

	mov al,bh
	and bh,0x07
	sub ax,0x80
	not ax
	and al,0xf8
	shl ax,0x03
	add di,ax	;di=(63-row)+(127-col)*8

	mov dl,bl
	sub dl,bh
	and dl,0x07	;this gets the number of bits to rotate while copying

	;bl=source bit offset
	;bh=dest. bit offset



	jmp short .enterLoop

.colLP	
	inc bx ;really inc bl
	and bl,0x07
	jnz .skipSourceByteAdjust
	add si,byte 5

.skipSourceByteAdjust

	inc bh
	and bh,0x07
	jnz .skipDestByteAdjust
	sub di,byte 64

.skipDestByteAdjust

	sub si,byte 5
	add di,byte 4

.enterLoop
	mov dh,cl

	mov ah,0x7f
	mov cl,bh
	ror ah,cl
	mov ch,ah
	not ch
	mov cl,dl

	es lodsb
	rol al,cl
	and al,ch
	and [di],ah
	or [di],al
	dec di
	es lodsb
	rol al,cl
	and al,ch
	and [di],ah
	or [di],al
	dec di
	es lodsb
	rol al,cl
	and al,ch
	and [di],ah
	or [di],al
	dec di
	es lodsb
	rol al,cl
	and al,ch
	and [di],ah
	or [di],al
	dec di
	es lodsb
	rol al,cl
	and al,ch
	and [di],ah
	or [di],al

	xor cx,cx
	mov cl,dh
	loop .colLP

        ;xchg es,ds
	mov ax,ds
	mov dx,es
	mov es,ax
	mov ds,dx

	ret


MF_ScrollUp:
	;scrolls the screen up 6 pixels, clearing the bottom 6 rows
	;"Scroll first, ask questions later"
	;on entry:
	;nothing
	;on return:
	;nothing
	;trashed:
	;nothing
	pushf
	std
	push ax
	push si
	push ds
	mov ax,es
	mov ds,ax
	push cx
	xor ax,ax   ;we want it blank when we clear the bottom
	mov si,0xffbe	;magic number I just dreamt up ...
	mov di,si
	mov cx,16
.scrollLoop
	push cx
	mov cl,29
	add si,122
	add di,128
	rep movsw
	mov cl,3
	rep stosw
	pop cx
	loop .scrollLoop
	pop cx
	pop ds
	pop si
	pop ax
	popf
	ret


MF_ClearScreen
	;clears the whole screen
	;on entry: nothing
	;on return: nothing
	;trashed: nothing
	pushf
	push cx
	push ax
	push di
	xor ax,ax
	mov [MF_CursorLocation],ax
	xor di,di
	mov cx,0x200
	rep stosw
	pop di
	pop ax
	pop cx
	popf


MF_GetCharData:
	;used internally
	;on entry:
	;AL = character
	;on exit:
	;AX = character data
	;trashed:
	;flags, BX
	and ax,0x00ff
	cmp al,32
	jl .nochar
	cmp al,97
	jl .cont
	cmp al,123
	jl .nochar
	cmp al,126
	jg .nochar
	sub al,26
.cont	sub al,32
	shl ax,1
	mov bx,ax
	mov ax,[bx+MF_fontdata]
	ret
.nochar	xor ax,ax
	ret

segment data

MF_fontdata:
;	db 0,0x00 ;10 linefeed

	db 0x02,234 ;32 space
	db 0x02,56 ;33 !
	db 0x04,76 ;34 "
	db 0x06,0 ;35 #
	db 0x06,6 ;36 $
	db 0x06,12 ;37 %
	db 0x06,18 ;38 &
	db 0x02,78 ;39 '
	db 0x03,24 ;40 (
	db 0x03,156 ;41 )
	db 0x04,27 ;42 *
	db 0x04,31 ;43 +
	db 0x03,35 ;44 ,
	db 0x04,38 ;45 -
	db 0x02,52 ;46 .
	db 0x04,42 ;47 /
	db 0x04,46 ;48 0
	db 0x04,50 ;49 1
	db 0x04,54 ;50 2
	db 0x04,58 ;51 3
	db 0x04,62 ;52 4
	db 0x04,66 ;53 5
	db 0x04,70 ;54 6
	db 0x04,74 ;55 7
	db 0x04,80 ;56 8
	db 0x04,84 ;57 9
	db 0x02,4 ;58 :
	db 0x02,169 ;59 ;
	db 0x04,88 ;60 <
	db 0x03,232 ;61 =
	db 0x04,92 ;62 >
	db 0x05,96 ;63 ?
	db 0x05,101 ;64 @
	db 0x04,106 ;65 A
	db 0x04,110 ;66 B
	db 0x04,114 ;67 C
	db 0x04,118 ;68 D
	db 0x03,122 ;69 E
	db 0x03,125 ;70 F
	db 0x04,128 ;71 G
	db 0x04,132 ;72 H
	db 0x02,48 ;73 I
	db 0x04,136 ;74 J
	db 0x04,140 ;75 K
	db 0x03,51 ;76 L
	db 0x06,144 ;77 M
	db 0x05,150 ;78 N
	db 0x04,155 ;79 O
	db 0x04,159 ;80 P
	db 0x04,163 ;81 Q
	db 0x04,167 ;82 R
	db 0x04,171 ;83 S
	db 0x04,175 ;84 T
	db 0x04,179 ;85 U
	db 0x04,185 ;86 V
	db 0x06,183 ;87 W
	db 0x04,189 ;88 X
	db 0x04,193 ;89 Y
	db 0x04,197 ;90 Z
	db 0x03,201 ;91 [
	db 0x04,204 ;92 \
	db 0x03,47 ;93 ]
	db 0x04,208 ;94 ^
	db 0x04,212 ;95 _
	db 0x03,216 ;96 `

	db 0x04,219 ;123 {
	db 0x02,142 ;124 |
	db 0x04,223 ;125 }
	db 0x05,227 ;126 ~


MF_fontimage:
	incbin "minifont.dat"

MF_CursorLocation:
MF_CursorCol:
	db 0x00
MF_CursorRow:
	db 0x00

